# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Credentials
  module Models
    #
    # Send offer.
    #
    class CredentialOfferParameters
      # @return [String] The credential definition identifier
      attr_accessor :definition_id

      # @return [String] Connection identifier to send this credential to.
      # If omitted, the request will be treated as connectionless issuance and
      # will generate a URL.
      attr_accessor :connection_id

      # @return [Boolean] If true, the credential will automatically be issued
      # once the individual accepts the offer.
      # If false, when an individual accepts the offer the credential will be
      # in state 'Requested' and must be manually issued.
      # Default value is 'false'.
      attr_accessor :automatic_issuance

      # @return [Hash{String => String}] Credential attribute values.
      # If using connectionless issuance, these attributes must be specified.
      # Must match all credential definition attribute names.
      attr_accessor :credential_values


      #
      # Mapper for CredentialOfferParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CredentialOfferParameters',
          type: {
            name: 'Composite',
            class_name: 'CredentialOfferParameters',
            model_properties: {
              definition_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'definitionId',
                type: {
                  name: 'String'
                }
              },
              connection_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectionId',
                type: {
                  name: 'String'
                }
              },
              automatic_issuance: {
                client_side_validation: true,
                required: false,
                serialized_name: 'automaticIssuance',
                type: {
                  name: 'Boolean'
                }
              },
              credential_values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'credentialValues',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
