# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Provider
  module Models
    #
    # Configuration options for creating new tenant
    #
    class TenantParameters
      # @return [String] The tenant identifier
      attr_accessor :tenant_id

      # @return [String] Issuer seed used for deterministic DID generation.
      # If omitted, a random DID/Key is generated.
      attr_accessor :issuer_seed

      # @return [String] The tenant name
      attr_accessor :name

      # @return [String] URL of tenant profile image
      attr_accessor :image_url

      # @return [String] Ledger network identifier.
      # Default value is Sovrin Staging (sovrin-staging).
      attr_accessor :network_id

      # @return [Enum] Possible values include: 'Shared', 'Dedicated',
      # 'Delegated'
      attr_accessor :endorser_type

      # @return [String] The geo-region where storage data will be located.
      attr_accessor :region


      #
      # Mapper for TenantParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TenantParameters',
          type: {
            name: 'Composite',
            class_name: 'TenantParameters',
            model_properties: {
              tenant_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              issuer_seed: {
                client_side_validation: true,
                required: false,
                serialized_name: 'issuerSeed',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              image_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'imageUrl',
                type: {
                  name: 'String'
                }
              },
              network_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'networkId',
                type: {
                  name: 'String'
                }
              },
              endorser_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endorserType',
                type: {
                  name: 'String'
                }
              },
              region: {
                client_side_validation: true,
                required: false,
                serialized_name: 'region',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
